#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ARRAYSIZE 5
#define NAMESIZE  51

struct TAdresse {char Nachname [NAMESIZE]; char Vorname [NAMESIZE]; int Gebjahr;};

int sortAdressFunction (const void *a, const void *b);

int main(int argc, char* argv[])
{
   TAdresse aMeinArray [ARRAYSIZE];

   strcpy (aMeinArray[0].Nachname, "Merkel");
   strcpy (aMeinArray[0].Vorname,  "Angela");
   aMeinArray[0].Gebjahr = 1954;

   strcpy (aMeinArray[1].Nachname, "Kohl");
   strcpy (aMeinArray[1].Vorname,  "Helmut");
   aMeinArray[1].Gebjahr = 1930;

   strcpy (aMeinArray[2].Nachname, "Kohl");
   strcpy (aMeinArray[2].Vorname,  "Hannelore");
   aMeinArray[2].Gebjahr = 1933;

   strcpy (aMeinArray[3].Nachname, "Brandt");
   strcpy (aMeinArray[3].Vorname,  "Willy");
   aMeinArray[3].Gebjahr = 1913;

   strcpy (aMeinArray[4].Nachname, "Schrder");
   strcpy (aMeinArray[4].Vorname,  "Gerhard");
   aMeinArray[4].Gebjahr = 1944;

   qsort((void *)aMeinArray, ARRAYSIZE, sizeof(TAdresse), sortAdressFunction);

   for (int i=0; i<ARRAYSIZE; i++)
   {
      printf ("%s, %s, %d\n", aMeinArray[i].Nachname, aMeinArray[i].Vorname, aMeinArray[i].Gebjahr);
   }
   return 0;
}

int sortAdressFunction (const void *a, const void *b)
{
  TAdresse x = *((TAdresse *)a);
  TAdresse y = *((TAdresse *)b);

  int nErgebnis = strcmp(x.Nachname, y.Nachname);
  if (!nErgebnis)
  {
     nErgebnis = strcmp(x.Vorname, y.Vorname);
     if (!nErgebnis)
     {
        if (x.Gebjahr < y.Gebjahr) nErgebnis = -1;
        if (x.Gebjahr > y.Gebjahr) nErgebnis =  1;
     }
  }
  return nErgebnis;
}
